---
title: Window.dump()
slug: Web/API/Window/dump
tags:
  - API
  - HTML DOM
  - Method
  - Non-standard
  - Window
---
<div>{{ ApiRef() }} {{Non-standard_header}}</div>

<p><code><strong>Window.dump()</strong></code> prints messages to the (native) console.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">window.dump(<em>message</em>);

dump(<em>message</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<ul>
 <li><code>message</code> is the string message to log.</li>
</ul>

<h2 id="Notes">Notes</h2>

<p>A common use of <code>dump()</code> is to debug JavaScript. The message passed to <code>dump()</code> is sent to the System Console (Native Console) if the Firefox process was started with the <code>-console</code> option. If the <code>-console</code> option was not specified then the output goes to stderr. Output from dump() is not sent to the <a href="/en-US/docs/Tools/Browser_Console">Browser Console</a>. Output can be sent to the <a href="/en-US/docs/Tools/Browser_Console">Browser Console</a> using <a href="/en-US/docs/Web/API/Console.log">console.log()</a>. Privileged code can also use <code><a href="/en-US/docs/Components.utils.reportError" title="Components.utils.reportError">Components.utils.reportError</a></code> and <code><a href="/en-US/docs/XPCOM_Interface_Reference/nsIConsoleService" title="nsIConsoleService">nsIConsoleService</a></code> to log messages to the <a href="/en-US/docs/Error_Console" title="Error_Console">Error Console</a>/<a href="/en-US/docs/Tools/Browser_Console">Browser Console</a>.</p>

<p><code>dump()</code> is also available to XPCOM components implemented in JavaScript, even though {{domxref("window")}} is not the global object in components. It is also explicitly made available in <a href="/en/docs/Components.utils.Sandbox#Methods_available_on_the_Sandbox_object" title="Methods available on the Sandbox object">sandboxes</a>. However, this use of <code>dump</code> is not affected by the preference mentioned below -- it will always be shown. It is therefore advisable to either check this preference yourself or use a debugging preference of your own to make sure you don't send lots of debugging content to a user's console when they might not be interested in it at all. Note that <code>dump</code> output from XPCOM components goes to <code>stderr</code>, while <code>dump </code>called elsewhere will output to <code>stdout</code>.</p>

<p>In <a href="/en-US/docs/Gecko" title="Gecko">Gecko</a> <code>dump()</code> is <strong>disabled by default</strong> – it doesn't do anything but doesn't raise an error either. To see the <code>dump</code> output you have to enable it by setting the preference <code>browser.dom.window.dump.enabled</code> to <code>true</code>. You can set the preference in <a href="http://kb.mozillazine.org/About:config">about:config</a> or in a <a href="http://kb.mozillazine.org/User.js_file">user.js file</a>. Note: this preference is not listed in <code>about:config</code> by default, you may need to create it (right-click the content area -&gt; New -&gt; Boolean).</p>

<p>On Windows, you will need a console to actually see anything. If you don't have one already, closing the application and re-opening it with the command line parameter <code>-console</code> should create the console or use <code>-attach-console</code> to use the existing console. On other operating systems, it's enough to launch the application from a terminal.</p>

<p>To redirect the console output to a file, run firefox <em>without </em>the -console option and use the syntax to redirect stderr and stdout to a file, i.e.:</p>

<pre>firefox &gt; console.txt 2&gt;&amp;1
</pre>

<div class="note">
<p>If you would like the console messages to appear in the console you used to launch the application, you can use the <a href="https://github.com/matthewkastor/Redirector">Gecko Console Redirector</a>. Precompiled binaries are available in the zipped archive <a href="https://github.com/matthewkastor/Redirector/archive/master.zip">https://github.com/matthewkastor/Redirector/archive/master.zip</a> under <code>Redirector-master\Gecko\Console Redirector\bin\Release</code> Copy all the dll's and the exe to wherever you want. Then run <code>Console Redirector.exe /?</code></p>
</div>

<h2 id="Specifications">Specifications</h2>

<p>This is not part of any specification</p>
